module ASM
  class Provider
    class Configuration
      class Idracinitialconfig < Provider::Base
        puppet_type "asm::idrac::initial_config"

        property :idrac_network_type,     :default => nil,             :validation => ["Static", "Existing"]
        property :idrac_networks,         :default => [],              :validation => Array
        property :idrac_cred_id,          :default => nil,             :validation => String

        # Determines if inventory should be run
        #
        # Overrides the base class method. The config job will change creds and/or IP which will result into inventory
        # failure since the flow uses outdated creds/IP. However, the invokers of this config job creates a new device
        # with new IP/creds, resulting in a new inventory run after this job completes. Hence, the inventory run is not
        # needed to be done as part of this config job.
        #
        # @return [Boolean] returns false to indicate inventory is not needed as part of this job
        def should_inventory?
          false
        end
      end
    end
  end
end
