require "asm/type"

module ASM
  class Type
    class Virtualmachine < Base
      def agent_certname
        provider.agent_certname
      end

      def deployed?
        provider.deployed?
      end

      # Returns the hostname for the VM
      #
      # @return [String]
      def hostname
        provider.hostname
      end

      # Returns the macaddress for corresponding network
      #
      # @param network [Hashie::Mash] A valid resource network interface as produced by {Type::Server#network_interfaces}
      # @see ASM::Processor::LinuxVMPostOS#process_rhel_network_config
      # @return [String]
      def macaddress(network=nil)
        provider.macaddress(network)
      end

      def os_image_type
        provider.os_image_type
      end

      def network_interfaces
        provider.network_interfaces
      end

      def default_gateway
        provider.default_gateway
      end

      def clone?
        provider.clone?
      end

      def os_image_version
        provider.os_image_version
      end
    end
  end
end
