require "spec_helper"
require "asm/type"

ASM::Type.load_providers!

describe ASM::Provider::Configuration::Idracinitialconfig do
  let(:logger) { stub(:debug => nil, :warn => nil, :info => nil) }
  let(:service) { SpecHelper.service_from_fixture("idrac_initial_config.json") }
  let(:config_components) { service.components.select { |c| c.resource_ids.include?("asm::idrac::initial_config") } }
  let(:type) { config_components[0].to_resource(nil, logger) }
  let(:provider) { type.provider }

  describe "#idrac_network_type" do
    it "should handle valid values correctly" do
      expect(provider.idrac_network_type).to eq("Static")
    end

    it "should raise error for invalid values" do
      expect { provider.idrac_network_type = "Foo" }.to raise_error(/idrac_network_type failed to validate/)
    end
  end

  describe "#should_inventory?" do
    it "should evaluate to false" do
      expect(provider.should_inventory?).to eq(false)
    end
  end
end
