namespace :integrate do
  desc "Run soft integration tests"
  task :soft do
    if RUBY_PLATFORM == "java" && !ENV["FORCE_INTEGRATE"]
      puts "Skipping soft integration runs on java"
      next
    end

    failures = []

    Dir.entries("spec/soft_integration").each do |file|
      next if file =~ /^\./

      test_dir = File.join("spec/soft_integration", file)

      next unless File.directory?(test_dir)

      sh("ruby spec/soft_integration/service_runner.rb --deployment %s" % test_dir) do |ok, res|
        unless ok
          failures << test_dir
          puts ">>> Test in %s failed" % test_dir
          puts
          puts
        end
      end
    end

    unless failures.empty?
      puts
      puts "Failed tests:"
      puts
      failures.each do |failure|
        puts "\t%s" % failure
      end
      exit(1)
    end
  end
end
